var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';

import _Input from './styled';

var Input = function Input(_ref) {
  var a11yLabel = _ref.a11yLabel,
      className = _ref.className,
      isFullWidth = _ref.isFullWidth,
      isLoading = _ref.isLoading,
      isRequired = _ref.isRequired,
      size = _ref.size,
      state = _ref.state,
      props = _objectWithoutProperties(_ref, ['a11yLabel', 'className', 'isFullWidth', 'isLoading', 'isRequired', 'size', 'state']);

  return React.createElement(_Input, _extends({
    'aria-invalid': state === 'danger',
    'aria-label': a11yLabel,
    'aria-required': isRequired,
    isFullWidth: isFullWidth,
    isLoading: isLoading,
    size: size,
    state: state
  }, props));
};

Input.defaultProps = {
  a11yLabel: null,
  as: null,
  autoFocus: false,
  className: null,
  defaultValue: undefined,
  disabled: false,
  id: null,
  isFullWidth: false,
  isLoading: false,
  isRequired: false,
  name: null,
  onBlur: null,
  onChange: null,
  onFocus: null,
  pattern: null,
  placeholder: null,
  size: 'default',
  state: null,
  type: 'text',
  value: undefined
};

export default Input;

/**
 * TODO:
 *
 * a11y properties:
 * - for/id labels
 */