var _class, _temp2;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import times from 'lodash/times';

import RatingStar from './RatingStar';
import { Rating as _Rating } from './styled';

var Rating = (_temp2 = _class = function (_Component) {
  _inherits(Rating, _Component);

  function Rating() {
    var _temp, _this, _ret;

    _classCallCheck(this, Rating);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      rating: _this.props.defaultRating,
      isSelecting: false,
      selectedIndex: null
    }, _this.handleStarClick = function (index) {
      var _this$props = _this.props,
          onRate = _this$props.onRate,
          disabled = _this$props.disabled,
          maxRating = _this$props.maxRating;

      var rating = index + 1;

      if (!disabled) {
        _this.setState({ rating: rating });
        onRate && onRate({ rating: rating, maxRating: maxRating });
      }
    }, _this.handleStarMouseOver = function (index) {
      var disabled = _this.props.disabled;

      !disabled && _this.setState({ isSelecting: true, selectedIndex: index });
    }, _this.handleMouseLeave = function () {
      _this.setState({ isSelecting: false });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  Rating.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        className = _props.className,
        size = _props.size,
        maxRating = _props.maxRating;
    var _state = this.state,
        rating = _state.rating,
        selectedIndex = _state.selectedIndex,
        isSelecting = _state.isSelecting;


    return React.createElement(
      _Rating,
      { className: className, onMouseLeave: this.handleMouseLeave },
      times(maxRating, function (index) {
        return React.createElement(RatingStar, {
          key: index,
          size: size,
          active: isSelecting ? selectedIndex >= index : rating >= index + 1,
          onClick: function onClick() {
            return _this2.handleStarClick(index);
          },
          onMouseEnter: function onMouseEnter() {
            return _this2.handleStarMouseOver(index);
          }
        });
      })
    );
  };

  return Rating;
}(Component), _class.defaultProps = {
  className: undefined,
  size: 'regular',
  defaultRating: 0,
  maxRating: 5,
  onRate: undefined,
  disabled: false
}, _temp2);


export default Rating;