'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Text = require('../Text');

var _Text2 = _interopRequireDefault(_Text);

var _styled = require('./styled');

var _styled2 = _interopRequireDefault(_styled);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Checkbox = function Checkbox(_ref) {
  var autoFocus = _ref.autoFocus,
      checked = _ref.checked,
      className = _ref.className,
      defaultChecked = _ref.defaultChecked,
      disabled = _ref.disabled,
      id = _ref.id,
      isRequired = _ref.isRequired,
      label = _ref.label,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      name = _ref.name,
      state = _ref.state,
      value = _ref.value,
      props = _objectWithoutProperties(_ref, ['autoFocus', 'checked', 'className', 'defaultChecked', 'disabled', 'id', 'isRequired', 'label', 'onBlur', 'onChange', 'onFocus', 'name', 'state', 'value']);

  return _react2.default.createElement(
    _styled2.default,
    _extends({
      'aria-describedby': 'label',
      'aria-invalid': state === 'danger',
      'aria-label': label,
      'aria-required': isRequired
    }, props),
    _react2.default.createElement(_styled.HiddenCheckbox, {
      autoFocus: autoFocus,
      checked: checked,
      defaultChecked: defaultChecked,
      disabled: disabled,
      id: id,
      onBlur: onBlur,
      onChange: onChange,
      onFocus: onFocus,
      name: name,
      state: state,
      type: 'checkbox',
      value: value
    }),
    _react2.default.createElement(_styled.CheckboxIcon, { state: state }),
    _react2.default.createElement(
      _Text2.default,
      { id: 'label', marginLeft: 'xxsmall' },
      label
    )
  );
};

Checkbox.defaultProps = {
  autoFocus: false,
  checked: undefined,
  className: null,
  defaultChecked: undefined,
  disabled: false,
  id: null,
  isRequired: false,
  onBlur: null,
  onChange: null,
  onFocus: null,
  name: null,
  state: null,
  value: undefined
};

exports.default = Checkbox;
module.exports = exports['default'];