'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styled = require('./styled');

var _styled2 = _interopRequireDefault(_styled);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Input = function Input(_ref) {
  var a11yLabel = _ref.a11yLabel,
      className = _ref.className,
      isFullWidth = _ref.isFullWidth,
      isLoading = _ref.isLoading,
      isRequired = _ref.isRequired,
      size = _ref.size,
      state = _ref.state,
      props = _objectWithoutProperties(_ref, ['a11yLabel', 'className', 'isFullWidth', 'isLoading', 'isRequired', 'size', 'state']);

  return _react2.default.createElement(_styled2.default, _extends({
    'aria-invalid': state === 'danger',
    'aria-label': a11yLabel,
    'aria-required': isRequired,
    isFullWidth: isFullWidth,
    isLoading: isLoading,
    size: size,
    state: state
  }, props));
};

Input.defaultProps = {
  a11yLabel: null,
  as: null,
  autoFocus: false,
  className: null,
  defaultValue: undefined,
  disabled: false,
  id: null,
  isFullWidth: false,
  isLoading: false,
  isRequired: false,
  name: null,
  onBlur: null,
  onChange: null,
  onFocus: null,
  pattern: null,
  placeholder: null,
  size: 'default',
  state: null,
  type: 'text',
  value: undefined
};

exports.default = Input;

/**
 * TODO:
 *
 * a11y properties:
 * - for/id labels
 */

module.exports = exports['default'];