'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styled = require('./styled');

var _Radio = require('./Radio');

var _Radio2 = _interopRequireDefault(_Radio);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var RadioGroup = function RadioGroup(_ref) {
  var a11yLabel = _ref.a11yLabel,
      className = _ref.className,
      defaultValue = _ref.defaultValue,
      disabled = _ref.disabled,
      id = _ref.id,
      onChange = _ref.onChange,
      options = _ref.options,
      name = _ref.name,
      state = _ref.state,
      value = _ref.value,
      props = _objectWithoutProperties(_ref, ['a11yLabel', 'className', 'defaultValue', 'disabled', 'id', 'onChange', 'options', 'name', 'state', 'value']);

  return _react2.default.createElement(
    _styled.RadioGroup,
    _extends({
      'aria-describedby': 'label',
      'aria-invalid': state === 'danger',
      'aria-label': a11yLabel,
      role: 'group'
    }, props),
    options.map(function (option, i) {
      return _react2.default.createElement(_Radio2.default, {
        key: i // eslint-disable-line
        , checked: typeof value === 'undefined' ? undefined : JSON.stringify(option.value) === JSON.stringify(value),
        defaultChecked: typeof defaultValue === 'undefined' ? undefined : JSON.stringify(option.value) === JSON.stringify(defaultValue),
        disabled: disabled || option.disabled,
        name: name,
        label: option.label,
        onChange: onChange ? function (e) {
          return onChange(e.target.value);
        } : undefined,
        state: state,
        value: option.value
      });
    })
  );
};

RadioGroup.defaultProps = {
  a11yLabel: undefined,
  className: undefined,
  defaultValue: undefined,
  disabled: false,
  id: undefined,
  onChange: undefined,
  state: undefined,
  value: undefined
};

exports.default = RadioGroup;
module.exports = exports['default'];