'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _primitives = require('../primitives');

var _styled = require('./styled');

var _styled2 = _interopRequireDefault(_styled);

var _Icon = require('./Icon');

var _Icon2 = _interopRequireDefault(_Icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Select = (_temp2 = _class = function (_PureComponent) {
  _inherits(Select, _PureComponent);

  function Select() {
    var _temp, _this, _ret;

    _classCallCheck(this, Select);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _PureComponent.call.apply(_PureComponent, [this].concat(args))), _this), _this.state = {
      isPlaceholderSelected: Boolean(_this.props.placeholder)
    }, _this.handleChange = function (e) {
      var onChange = _this.props.onChange;

      _this.setState({ isPlaceholderSelected: false });
      onChange && onChange(e.target.value);
    }, _this.render = function () {
      var _this$props = _this.props,
          a11yLabel = _this$props.a11yLabel,
          className = _this$props.className,
          autoFocus = _this$props.autoFocus,
          defaultValue = _this$props.defaultValue,
          disabled = _this$props.disabled,
          id = _this$props.id,
          isFullWidth = _this$props.isFullWidth,
          isRequired = _this$props.isRequired,
          name = _this$props.name,
          onBlur = _this$props.onBlur,
          onChange = _this$props.onChange,
          onFocus = _this$props.onFocus,
          options = _this$props.options,
          placeholder = _this$props.placeholder,
          size = _this$props.size,
          state = _this$props.state,
          value = _this$props.value,
          props = _objectWithoutProperties(_this$props, ['a11yLabel', 'className', 'autoFocus', 'defaultValue', 'disabled', 'id', 'isFullWidth', 'isRequired', 'name', 'onBlur', 'onChange', 'onFocus', 'options', 'placeholder', 'size', 'state', 'value']);

      var isPlaceholderSelected = _this.state.isPlaceholderSelected;

      return _react2.default.createElement(
        _primitives.InlineBlock,
        _extends({ relative: true, width: isFullWidth ? '100%' : undefined }, props),
        _react2.default.createElement(
          _styled2.default,
          {
            'aria-invalid': state === 'danger',
            'aria-label': a11yLabel,
            'aria-required': isRequired,
            autoFocus: autoFocus,
            defaultValue: defaultValue || placeholder,
            disabled: disabled,
            id: id,
            isFullWidth: isFullWidth,
            isPlaceholderSelected: isPlaceholderSelected,
            name: name,
            onBlur: onBlur,
            onChange: _this.handleChange,
            onFocus: onFocus,
            size: size,
            state: state,
            value: value
          },
          placeholder && _react2.default.createElement(
            'option',
            { disabled: true },
            placeholder
          ),
          options.map(function (option, i) {
            return _react2.default.createElement(
              'option',
              {
                key: i // eslint-disable-line
                , disabled: disabled || option.disabled,
                value: option.value
              },
              option.label
            );
          })
        ),
        _react2.default.createElement(_Icon2.default, null)
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return Select;
}(_react.PureComponent), _class.defaultProps = {
  a11yLabel: undefined,
  autoFocus: false,
  className: undefined,
  defaultValue: undefined,
  disabled: false,
  id: undefined,
  isFullWidth: false,
  isLoading: false,
  isRequired: false,
  name: undefined,
  onBlur: undefined,
  onChange: undefined,
  onFocus: undefined,
  placeholder: undefined,
  size: 'default',
  state: undefined,
  value: undefined
}, _temp2);
exports.default = Select;
module.exports = exports['default'];